<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GeneraCotizacionResponse StructType
 * @subpackage Structs
 */
class GeneraCotizacionResponse extends AbstractStructBase
{
    /**
     * The Fault
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Fault
     */
    public $Fault;
    /**
     * The NumeroCotizacion
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $NumeroCotizacion;
    /**
     * Constructor method for GeneraCotizacionResponse
     * @uses GeneraCotizacionResponse::setFault()
     * @uses GeneraCotizacionResponse::setNumeroCotizacion()
     * @param \StructType\Fault $fault
     * @param string $numeroCotizacion
     */
    public function __construct(\StructType\Fault $fault = null, $numeroCotizacion = null)
    {
        $this
            ->setFault($fault)
            ->setNumeroCotizacion($numeroCotizacion);
    }
    /**
     * Get Fault value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Fault|null
     */
    public function getFault()
    {
        return isset($this->Fault) ? $this->Fault : null;
    }
    /**
     * Set Fault value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Fault $fault
     * @return \StructType\GeneraCotizacionResponse
     */
    public function setFault(\StructType\Fault $fault = null)
    {
        if (is_null($fault) || (is_array($fault) && empty($fault))) {
            unset($this->Fault);
        } else {
            $this->Fault = $fault;
        }
        return $this;
    }
    /**
     * Get NumeroCotizacion value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNumeroCotizacion()
    {
        return isset($this->NumeroCotizacion) ? $this->NumeroCotizacion : null;
    }
    /**
     * Set NumeroCotizacion value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $numeroCotizacion
     * @return \StructType\GeneraCotizacionResponse
     */
    public function setNumeroCotizacion($numeroCotizacion = null)
    {
        // validation for constraint: string
        if (!is_null($numeroCotizacion) && !is_string($numeroCotizacion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($numeroCotizacion)), __LINE__);
        }
        if (is_null($numeroCotizacion) || (is_array($numeroCotizacion) && empty($numeroCotizacion))) {
            unset($this->NumeroCotizacion);
        } else {
            $this->NumeroCotizacion = $numeroCotizacion;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GeneraCotizacionResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
